Ruby: include/ruby/vm.h File Reference

Ruby 3.2.5p208 (2024-07-26 revision 31d0f1a2e7dbfb60731d1f05b868e1d578cda493)

Typedefs | Functions
vm.h File Reference
`#include "ruby/internal/dllexport.h"`

Go to the source code of this file.

## Typedefs
typedef struct rb_vm_struct | ruby_vm_t
| The opaque struct to hold VM internals.

## Functions
int | ruby_vm_destruct (ruby_vm_t *vm)
| Destructs the passed VM.
void | ruby_vm_at_exit (void(*func)(ruby_vm_t *))
| ruby_vm_at_exit registers a function func to be invoked when a VM passed away.

## Detailed Description

Author
  $Author$

Date
  Sat May 31 15:17:36 2008

Copyright
  Copyright (C) 2008 Yukihiro Matsumoto
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

We planned to have multiple VMs run side-by-side. The API here was a preparation of that feature. The topic branch was eventually abandoned, and we now have Ractor. This file is kind of obsolescent.

Definition in file vm.h.

## Typedef Documentation

## ◆ ruby_vm_t

typedef struct rb_vm_struct ruby_vm_t

The opaque struct to hold VM internals.

Its fields are intentionally hidden from extension libraries because it changes drastically time to time.

Definition at line 25 of file vm.h.

## Function Documentation

## ◆ ruby_vm_at_exit()

void ruby_vm_at_exit | ( | void(* | func )(ruby_vm_t *) | ) |

ruby_vm_at_exit registers a function func to be invoked when a VM passed away.

Functions registered this way runs in reverse order of registration, just like END {} block does. The difference is its timing to be triggered. ruby_vm_at_exit functions runs when a VM passed away, while END {} blocks runs just before a VM is passing away.

You cannot register a function to another VM than where you are in. So where to register is intuitive, omitted. OTOH the argument func cannot know which VM it is in because at the time of invocation, the VM has already died and there is no execution context. The VM itself is passed as the first argument to it.

Parameters

  [in] | func | the function to register.

Definition at line 778 of file vm.c.

## ◆ ruby_vm_destruct()

int ruby_vm_destruct | ( | ruby_vm_t * | vm | ) |

Destructs the passed VM.

You don't have to call this API directly now, because there is no way to create one. There is only one VM at one time. ruby_stop() should just suffice.

Definition at line 2862 of file vm.c.